"use strict";const{delay:delay,ServiceBusClient:ServiceBusClient,ServiceBusMessage:ServiceBusMessage}=require("@azure/service-bus"),{object:object}=require("joi"),request=require("request"),pluginCommon=require("./plugin-common"),effilogger=require("../logger/effilogger"),tools=require("../responses"),throttle=require("express-throttle"),PLUGIN_ID="azure-service-bus";var servicebus_service={asb_sbClient:null,asb_receiver:null},servicebus_input={asb_sbClient:null,asb_receiver:null,status:"stopped"},servicebus_output={asb_sbClient:null,asb_sender:null},disposingInProgress=!1,myMessageHandler=null,myServiceHandler=null,myErrorHandler=null,myServiceErrorHandler=null;async function InitModule(e,s){effilogger.effilogger.debug(`[${PLUGIN_ID}] Initializing .....`),effilogger.effilogger.debug(`[${PLUGIN_ID}] initializing input queue .....`),servicebus_input.asb_sbClient=new ServiceBusClient(e.input.connectionstring),servicebus_input.asb_receiver=servicebus_input.asb_sbClient.createReceiver(e.input.queuename),e.output.active&&(effilogger.effilogger.debug(`[${PLUGIN_ID}] initializing output queue .....`),servicebus_output.asb_sbClient=new ServiceBusClient(e.output.connectionstring),servicebus_output.asb_sender=servicebus_output.asb_sbClient.createSender(e.output.queuename)),e.service.active&&(effilogger.effilogger.debug(`[${PLUGIN_ID}] initializing service queue .....`),servicebus_service.asb_sbClient=new ServiceBusClient(e.service.connectionstring),servicebus_service.asb_receiver=servicebus_service.asb_sbClient.createReceiver(e.service.queuename)),effilogger.effilogger.debug(`[${PLUGIN_ID}] creating handlers .....`),myMessageHandler=(async r=>{const i=typeof r.body;effilogger.effilogger.info(`[${PLUGIN_ID}] Received message: ${r.body} = '${i}'`);var t="/paragon",o="POST";null!=r.applicationProperties&&null!=r.applicationProperties.path&&(t=r.applicationProperties.path),null!=r.applicationProperties&&null!=r.applicationProperties.method&&(o=r.applicationProperties.method);var n=r.body;pluginCommon.processRestAPI(PLUGIN_ID,e,s,t,o,n,r,sendBackAsyncRespose)}),myServiceHandler=(async r=>{const i=typeof r.body;effilogger.effilogger.info(`[${PLUGIN_ID}] Received service message: ${r.body} = '${i}'`);var t="/paragon",o="POST";null!=r.applicationProperties&&null!=r.applicationProperties.path&&(t=r.applicationProperties.path),null!=r.applicationProperties&&null!=r.applicationProperties.method&&(o=r.applicationProperties.method);var n=r.body;pluginCommon.processRestAPI(PLUGIN_ID,e,s,t,o,n,r,sendBackAsyncServiceResponse)}),myErrorHandler=(async r=>{effilogger.effilogger.error(`[${PLUGIN_ID}][input queue]  generic error : `+JSON.stringify(r)),disposingInProgress||(disposingInProgress=!0,await DisposeModule(),e.reinitOnError&&setTimeout(async function(){effilogger.effilogger.info(`[${PLUGIN_ID}] reinitializing ...`),await InitModule(e,s),disposingInProgress=!1},e.reinitDelay))}),myServiceErrorHandler=(async r=>{effilogger.effilogger.error(`[${PLUGIN_ID}][service queue] generic error : `+JSON.stringify(r)),disposingInProgress||(disposingInProgress=!0,await DisposeModule(),e.reinitOnError&&setTimeout(async function(){effilogger.effilogger.info(`[${PLUGIN_ID}] reinitializing ...`),await InitModule(e,s),disposingInProgress=!1},e.reinitDelay))}),servicebus_input.asb_receiver.subscribe({processMessage:myMessageHandler,processError:myErrorHandler},{autoCompleteMessages:!!e.input.autoack}),servicebus_input.status="consuming",e.service.active&&servicebus_service.asb_receiver.subscribe({processMessage:myServiceHandler,processError:myServiceErrorHandler},{autoCompleteMessages:!!e.service.autoack})}async function sendBackAsyncServiceResponse(e,s,r,i){if(0==e.input.autoack&&(r||null==i||i instanceof Object==0||0==i.ok?await servicebus_service.asb_receiver.deadLetterMessage(s,{deadLetterReason:null!=r?r:"PosnetServerProcessingError",deadLetterErrorDescription:"request error : "+(null!=i?JSON.stringify(i):"check posnetserver logs")}):await servicebus_service.asb_receiver.completeMessage(s)),e.output.active){let e=await servicebus_output.asb_sender.createMessageBatch();e.tryAddMessage({body:i,contentType:"application/json"})?(await servicebus_output.asb_sender.sendMessages(e),effilogger.effilogger.info(`[${PLUGIN_ID}] replied to output queue: `+JSON.stringify(i))):effilogger.effilogger.error(`[${PLUGIN_ID}] Message too big to fit in a batch`)}}async function sendBackAsyncRespose(e,s,r,i){if(0==e.input.autoack&&(r||null==i||i instanceof Object==0||0==i.ok?await servicebus_input.asb_receiver.deadLetterMessage(s,{deadLetterReason:null!=r?r:"PosnetServerProcessingError",deadLetterErrorDescription:"request error : "+(null!=i?JSON.stringify(i):"check posnetserver logs")}):await servicebus_input.asb_receiver.completeMessage(s)),e.output.active){let e=await servicebus_output.asb_sender.createMessageBatch();e.tryAddMessage({body:i,contentType:"application/json"})?(await servicebus_output.asb_sender.sendMessages(e),effilogger.effilogger.info(`[${PLUGIN_ID}] replied to output queue: `+JSON.stringify(i))):effilogger.effilogger.error(`[${PLUGIN_ID}] Message too big to fit in a batch`)}}async function DisposeModule(){servicebus_input.status="stopped",null!=servicebus_input.asb_receiver&&await servicebus_input.asb_receiver.close(),null!=servicebus_input.asb_sbClient&&await servicebus_input.asb_sbClient.close(),null!=servicebus_output.asb_sender&&await servicebus_output.asb_sender.close(),null!=servicebus_output.asb_sbClient&&await servicebus_output.asb_sbClient.close(),null!=servicebus_service.asb_sender&&await servicebus_service.asb_sender.close(),null!=servicebus_service.asb_sbClient&&await servicebus_service.asb_sbClient.close()}function HasRestExtension(){return!0}function ProcessRestExtension(e,s,r){s.post(`/${PLUGIN_ID}/consume/pause`,throttle(r),(e,s)=>{if("stopped"==servicebus_input.status)return effilogger.effilogger.debug(`[${PLUGIN_ID}] Not consuming from the queue. Resume consumption first.`),tools.resp_error(s,"Not consuming from the queue. Resume consumption first.");effilogger.effilogger.debug(`[${PLUGIN_ID}] Pausing consumption .....`),servicebus_input.asb_receiver.close().then(e=>(servicebus_input.status="stopped",effilogger.effilogger.debug(`[${PLUGIN_ID}] Consumption paused`),tools.resp_success(s,null))).catch(e=>tools.resp_error(s,e))}),s.post(`/${PLUGIN_ID}/consume/resume`,throttle(r),(s,r)=>{if("consuming"==servicebus_input.status)return tools.resp_error(r,"Already consuming from the queue.");try{return effilogger.effilogger.debug(`[${PLUGIN_ID}] Resuming consumption .....`),servicebus_input.asb_sbClient=new ServiceBusClient(e.input.connectionstring),servicebus_input.asb_receiver=servicebus_input.asb_sbClient.createReceiver(e.input.queuename),servicebus_input.asb_receiver.subscribe({processMessage:myMessageHandler,processError:myErrorHandler},{autoCompleteMessages:!!e.input.autoack}),servicebus_input.status="consuming",effilogger.effilogger.debug(`[${PLUGIN_ID}] Consumption resumed`),tools.resp_success(r,null)}catch(e){return tools.resp_error(r,e)}}),s.get(`/${PLUGIN_ID}/consume/status`,throttle(r),(e,s)=>{var r={ok:!0,status:servicebus_input.status};return tools.resp_success(s,r)})}module.exports.InitModule=InitModule,module.exports.DisposeModule=DisposeModule,module.exports.HasRestExtension=HasRestExtension,module.exports.ProcessRestExtension=ProcessRestExtension;